/*
Snake Snake fish fish
Nutsumiya , White Squirrel
// 0 = start screen , 1 = game , 2 = score screen
*/
#define F_CPU 16000000UL 
#include <avr/io.h>
#include <util/delay.h>
#define size 6
#define max_fre 300
#define max_fre_two 30
#define max_fre_game 300 << ปรับความเร็วเกม

int slot=0;
char data[size][size];
char frame[size][50];
int size_frame;
int i_frame;
int fre;
int two_status=0;
int stage;
int press[4];

int dir;
int x,y;
int unit;



void runningScreen()
{
	int i,j;
	for(j=0;j<size;j++)
	{
		if(i_frame-size+j<0||i_frame-size+j>size_frame+6)
		{
			for(i=0;i<size;i++)
			{
				data[i][j]=0;
			}
		}else{
			for(i=0;i<size;i++)
			{
				data[i][j]=frame[i][i_frame-size+j];
			}
		}
	}
	i_frame++;
	if(i_frame>size_frame+6)i_frame=0;
}



void clearFrame(int x)
{
	int i,j;
	size_frame=x;
	for(i=0;i<size;i++)
	{
		for(j=0;j<50;j++)
		{
			frame[i][j]=0;
		}
	}
	i_frame=1;
}

void f(int x,int y)
{
	frame[x][y]=1;
}

void drawName()
{
	clearFrame(22);
	f(1,1);	f(1,2);	f(1,3);	f(2,1);	f(3,1);	f(3,2);	f(3,3);	f(4,3);	f(5,1);	f(5,2);	f(5,3); // S
	f(3,5);f(3,6);f(3,7);f(4,5);f(4,7);f(5,5);f(5,7);// n
	f(2,10);f(3,9);f(3,11);f(4,9);f(4,10);f(4,11);f(5,9);f(5,11);//A
	f(2,13);f(2,15);f(3,13);f(3,14);f(4,13);f(4,15);f(5,13);f(5,15);//K
	f(1,17);f(1,18);f(1,19);f(1,20);f(2,17);f(3,17);f(3,18);f(3,19);f(4,17);f(5,17);f(5,18);f(5,19);f(5,20);//E
}

void scanLight()
{
	int i;
	int mul=32;
	PORTB = 1<<slot;
	PORTC = 0;
	for(i=0;i<size;i++,mul/=2)
	{
		if(data[slot][i]==0)
		{
			PORTC+=mul;
		}
		if(two_status==0&&data[slot][i]==-1)
		{
			PORTC+=mul;
		}
	}
	slot++;
	if(slot>=size)
	{
		slot=0;
		if(fre%max_fre_two==0)
		{
			two_status=two_status==0?1:0;
		}
	}
}

void clearData()
{
	int i,j;
	for(i=0;i<size;i++)
	{
		for(j=0;j<size;j++)
		{
			data[i][j]=0;
		}
	}
	for(i=0;i<4;i++)press[i]=0;
}

void makeHeart()
{
	data[0][1]=-1;
	data[0][3]=-1;
	data[1][0]=-1;
	data[1][2]=-1;
	data[1][4]=-1;
	data[2][0]=-1;
	data[2][4]=-1;
	data[3][1]=-1;
	data[3][3]=-1;
	data[4][2]=-1;
}

////////////////////////// ปรับทิศทางการควบคุมจากตรงนี้
int input()
{
	if((PIND&0b00000001)!=0)return 2;
	if((PIND&0b00000010)!=0)return 1;
	if((PIND&0b00100000)!=0)return 4;
	if((PIND&0b01000000)!=0)return 3;
	return 0;
}
/////////////////////////////

void init()
{
    int i,j;
    for(i=0;i<size;i++)
    {
        for(j=0;j<size;j++)
        {
             data[i][j]=0;
        }
    }
	dir=2;
	x=2;
	y=3;
	unit=2;
	data[2][3]=2;
	data[2][2]=1;
	srand(fre);
}

void addEgg()
{
	int ex,ey;
	while(1)
	{
		ex=rand()%size;
		ey=rand()%size;
		if(data[ex][ey]==0)
		{
			data[ex][ey]=-1;
			return;
		}
	}
}

void setNumberAt(int px,int py,int n)
{
	switch(n)
	{
		case 0:if(py==0)return;
			   frame[px][py]=1;frame[px][py+1]=1;frame[px][py+2]=1;
			   frame[px+1][py]=1;frame[px+1][py+2]=1;
			   frame[px+2][py]=1;frame[px+2][py+2]=1;
			   frame[px+3][py]=1;frame[px+3][py+2]=1;
			   frame[px+4][py]=1;frame[px+4][py+1]=1;frame[px+4][py+2]=1;
			   break;
		case 1:frame[px][py+2]=1;
			   frame[px+1][py+2]=1;
			   frame[px+2][py+2]=1;
			   frame[px+3][py+2]=1;
			   frame[px+4][py+2]=1;
			   break;
	    case 2:frame[px][py]=1;frame[px][py+1]=1;frame[px][py+2]=1;
			   frame[px+1][py+2]=1;
			   frame[px+2][py]=1;frame[px+2][py+1]=1;frame[px+2][py+2]=1;
			   frame[px+3][py]=1;
			   frame[px+4][py]=1;frame[px+4][py+1]=1;frame[px+4][py+2]=1;
			   break;
		case 3:frame[px][py]=1;frame[px][py+1]=1;frame[px][py+2]=1;
			   frame[px+1][py+2]=1;
			   frame[px+2][py]=1;frame[px+2][py+1]=1;frame[px+2][py+2]=1;
			   frame[px+3][py+2]=1;
			   frame[px+4][py]=1;frame[px+4][py+1]=1;frame[px+4][py+2]=1;
			   break;
		case 4:frame[px][py]=1;frame[px][py+2]=1;
			   frame[px+1][py]=1;frame[px+1][py+2]=1;
			   frame[px+2][py]=1;frame[px+2][py+1]=1;frame[px+2][py+2]=1;
			   frame[px+3][py+2]=1;
			   frame[px+4][py+2]=1;
			   break;
		case 5:frame[px][py]=1;frame[px][py+1]=1;frame[px][py+2]=1;
			   frame[px+1][py]=1;
			   frame[px+2][py]=1;frame[px+2][py+1]=1;frame[px+2][py+2]=1;
			   frame[px+3][py+2]=1;
			   frame[px+4][py]=1;frame[px+4][py+1]=1;frame[px+4][py+2]=1;
			   break;
		case 6:frame[px][py]=1;frame[px][py+1]=1;frame[px][py+2]=1;
			   frame[px+1][py]=1;
			   frame[px+2][py]=1;frame[px+2][py+1]=1;frame[px+2][py+2]=1;
			   frame[px+3][py]=1;frame[px+3][py+2]=1;
			   frame[px+4][py]=1;frame[px+4][py+1]=1;frame[px+4][py+2]=1;
			   break;
		case 7:frame[px][py]=1;frame[px][py+1]=1;frame[px][py+2]=1;
			   frame[px+1][py+2]=1;
			   frame[px+2][py+2]=1;
			   frame[px+3][py+2]=1;
			   frame[px+4][py+2]=1;
			   break;
		case 8:frame[px][py]=1;frame[px][py+1]=1;frame[px][py+2]=1;
			   frame[px+1][py]=1;frame[px+1][py+2]=1;
			   frame[px+2][py]=1;frame[px+2][py+1]=1;frame[px+2][py+2]=1;
			   frame[px+3][py]=1;frame[px+3][py+2]=1;
			   frame[px+4][py]=1;frame[px+4][py+1]=1;frame[px+4][py+2]=1;
			   break;
		case 9:frame[px][py]=1;frame[px][py+1]=1;frame[px][py+2]=1;
			   frame[px+1][py]=1;frame[px+1][py+2]=1;
			   frame[px+2][py]=1;frame[px+2][py+1]=1;frame[px+2][py+2]=1;
			   frame[px+3][py+2]=1;
			   frame[px+4][py]=1;frame[px+4][py+1]=1;frame[px+4][py+2]=1;
			   break;
	}
}

void setInt(int x)
{
	clearFrame(7);
	setNumberAt(1,4,(x)%10);
	setNumberAt(1,0,(x)/10);
}

int countToStage0;

void stage2()//score
{
	if(fre%max_fre==0)
	{
		runningScreen();
		if(++countToStage0>13)
		{
			stage=0;
			clearData();
			drawName();
		}
	}
}

void stage0()// title 
{
	int iInput=input();
	int i;
	int tmp=0;
	if(fre%max_fre==0)
	{
		runningScreen();
	}
	if(iInput>0)press[iInput-1]=1;
	for(i=0;i<4;i++)
	{
		if(press[i]==1)
		{
			data[0][i+1]=-1;
			tmp++;		
		}
	}
	if(tmp==4)
	{
		stage=1;
		init();
		addEgg();
	}
}

void stage1()// game
{
	int i,j;
	if(fre%300!=0)return ;
	switch(input())
	{
		case 4:if(dir!=2)dir=4;break;
		case 3:if(dir!=1)dir=3;break;
		case 2:if(dir!=4)dir=2;break;
		case 1:if(dir!=3)dir=1;break;		
	}
	switch(dir)
	{
		case 1: x--;break;
		case 2: y++;break;
		case 3: x++;break;
		case 4: y--;break;
	}
	if(x<0)x=size-1;
	if(x>=size)x=0;
	if(y<0)y=size-1;
	if(y>=size)y=0;


	// check eat
	if(data[x][y]==-1){
		unit++;
		addEgg();
	}
	// check die
	if(data[x][y]>1){
		clearData();
		
		setInt(unit-2);
		countToStage0=0;
		stage=2;
	}	
	//	

	for(i=0;i<size;i++)
	{
		for(j=0;j<size;j++)
		{
			if(data[i][j]>0)data[i][j]--;
		}
	}
	data[x][y]=unit;

	
}

main()
{ 
	int i=0,j=0;
    DDRC  |= 0b00111111;  
	DDRB  |= 0b00111111; 
	DDRD  &= 0b10011100;
	clearData();
	drawName();
    while (1)
    {
		switch(stage)
		{
			case 0:stage0();break;
			case 1:stage1();break;
			case 2:stage2();break;
		}
		fre++;
		if(fre>=300)fre=0;
      	scanLight();
        _delay_ms(1);
    }
}
